routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth::routes([
  'register' => false, // Registration Routes...
  'reset' => false, // Password Reset Routes...
  'verify' => false, // Email Verification Routes...
]);

Route::group(['middleware' => ['auth']], function() {
    Route::resource('roles','RoleController');
    Route::resource('users','UserController');
    Route::resource('projects','ProjectController');
    Route::resource('tasks','TaskController');
    Route::resource('comments','CommentController');
    Route::resource('logworks','LogworkController');
    
    ROute::get('changestatusproject/{id}/{pid}','ProjectController@changeStatus');
    Route::get('logworkremoved/{id}','LogworkController@is_removed');
    Route::get('download-logworks/{name}','LogworkController@download');
    Route::get('commentremoved/{id}','CommentController@is_removed');
    Route::get('download-comments/{name}','CommentController@download');
    Route::get('create-task/{id}','TaskController@createTicket');
    Route::get('task/{id}','TaskController@index');
    Route::get('download-attachemnt/{name}','TaskController@download');
});

Route::get('/home', 'HomeController@index')->name('home');
Route::resource('yourwork','YourworkController');
Route::get('projectExcel','ProjectController@excel');
Route::get('userBlock/{id}','UserController@userBlock');
Route::get('editUser/{id}','UserController@editUser');
Route::put('updateUser/{id}','UserController@updateUser');
Route::get('changePassword/{id}','UserController@changePassword');
Route::put('updatePassword/{id}','UserController@updatePassword');
Route::resource('logs','LogController');
Route::get('download/{filename}', 'LogController@getDownload');
// LocalizationController
Route::get('lang/{locale}', 'LocalizationController@index');
// ROUTE for getImage from photos folder
Route::get('/photos/{filename}', function ($filename)
{
    $path = storage_path() . '/photos/' . $filename;
    if(!File::exists($path)) abort(404);
    $file = File::get($path);
    $type = File::mimeType($path);
    $response = Response::make($file, 200);
    $response->header("Content-Type", $type);
    return $response;
})->name('photo');

app/User.php
<?php

namespace App;

use Illuminate\Contracts\Auth\MustVerifyEmail;
use Illuminate\Foundation\Auth\User as Authenticatable;
use Illuminate\Notifications\Notifiable;
use Spatie\Permission\Traits\HasRoles;

class User extends Authenticatable
{
    use Notifiable;
    use HasRoles;
    /**
     * The attributes that are mass assignable.
     *
     * @var array
     */

    /**
     * The attributes excluded from the model's JSON form.
     *
     * @var array
     */
    public function projects()
    {
        return $this->belongsToMany('App\Project', 'App\ProjectUser','user_id', 'project_id');
    }

    protected $fillable = [
        'name', 'email', 'password', 'phone', 'photo' , 'role', 'status', 'description','blocked_date',
    ];

    /**
     * The attributes that should be hidden for arrays.
     *
     * @var array
     */
    protected $hidden = [
        'password', 'remember_token',
    ];

    /**
     * The attributes that should be cast to native types.
     *
     * @var array
     */
    protected $casts = [
        'email_verified_at' => 'datetime',
    ];
}

app/Http/Controllers/UserController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Illuminate\Support\Facades\File;
use Illuminate\Support\Facades\Storage;
use Spatie\Permission\Models\Permission;
use Spatie\Permission\Models\Role;
use Illuminate\Support\Facades\Hash;
use DB;
use App\User;
use Auth;

class UserController extends Controller
{
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */

    public function index(Request $request)
    {        
        $data = User::orderBy('id','DESC')->paginate(5);
        $data1 = array(
            'title'=>'Users',
            'description'=>'This is New Application',
            'author'=>'foo'
            );
        return view('users.index',compact('data'))->with('i', ($request->input('page', 1) - 1) * 5)->with($data1);
    }


    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $roles = Role::all();
        $data1 = array(
            'title'=>'Users',
            'description'=>'This is New Application',
            'author'=>'foo'
            );
        return view('users.create',compact('roles'))->with($data1);
    }


    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response1
     */
    public function store(Request $request)
    {        
        $this->validate($request, [
            'name' => 'required',
            'email' => 'required|email|unique:users,email',
            'password' => 'required|same:confirm-password',
            'roles' => 'required',
            'description' => 'required'
        ]);

        $input = $request->all();
        if($request->hasFile('file')){
            if ($files = $input['photo']) {
                $image = $request->file('photo');
                $new_name = date('YmdHis').'_'.rand() .'_user_'. '.' . $image->getClientOriginalExtension();
                $image->move(public_path('photos'), $new_name);
            } 
        } $new_name = "null"; 

        $password = Hash::make($input['password']);
        $user= new User();
            $user->name= $input['name'];
            $user->email= $input['email'];
            $user->password= $password;
            $user->phone= $input['phone'];
            $user->photo= $new_name;
            $user->status= "1";
            $user->description=  $input['description'];
        $user->save();

        //$user = User::create($input);
        $user->assignRole($request->input('roles'));
        $notification = array(
            'message' => 'User has been created successfully.', 
            'alert-type' => 'success',
        );
        
        return redirect()->route('users.index')->with($notification);
    }


    /**
     * Display the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function show($id)
    {
        $user = User::find($id);
        $data1 = array(
            'title'=>'Users',
            'description'=>'This is New Application',
            'author'=>'foo'
            );
        return view('users.show',compact('user'))->with($data1);
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $user = User::find($id);
        $roles = Role::pluck('name','name')->all();
        $userRole = $user->roles->pluck('name','name')->all();
        $data1 = array(
            'title'=>'Users',
            'description'=>'This is New Application',
            'author'=>'foo'
            );

        return view('users.edit',compact('user','roles','userRole'))->with($data1);
    }


    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'name' => 'required',
            'email' => 'required|email|unique:users,email,'.$id,
            'roles' => 'required',
            'description' => 'required'
        ]);

        $input = $request->all();
        //      
        if($request->hasFile('photo')){
        $image = $request->file('photo');
            if($image != '')
            {
                $image_name = date('YmdHis').'_user_'.rand() . '.' . $image->getClientOriginalExtension();
                $image->move(public_path('photos'), $image_name);
            }
        }else $image_name = "null";
        // $password = Hash::make($input['password']);

        // if(!empty($input['password'])){ 
        //     $input['password'] = Hash::make($input['password']);
        // }else{
        //     $input = array_except($input,array('password'));    
        // }


        $user = User::find($id);
            $user->name= $input['name'];
            $user->email= $input['email'];
            $user->phone= $input['phone'];
            $user->photo= $image_name;
            $user->status= "1";
            $user->description=  $input['description'];
        $user->save();

        DB::table('model_has_roles')->where('model_id',$id)->delete();

        $user->assignRole($request->input('roles'));

        $notification = array(
            'message' => 'User has been updated successfully.', 
            'alert-type' => 'success',
        );
        return redirect()->route('users.index')->with($notification);
    }

    public function editUser($id)
    {
        $user = User::find($id);
        return view('users.edit_user',compact('user'));
    }

    public function updateUser(Request $request, $id)
    {
        $input = $request->all();
        $user = User::find($id);
            $user->name= $input['name'];
            $user->email= $input['email'];
            $user->phone= $input['phone'];
        $user->save();
        $notification = array(
            'message' => 'User has been updated successfully.', 
            'alert-type' => 'success',
        );
        return back()->with($notification);
    }

    public function changePassword($id)
    {
        $user = User::find($id);
        return view('users.change_password',compact('user'));
    }

    public function updatePassword(Request $request, $id)
    {
        $this->validate($request, [
            'password'     => 'required|min:8',
            'password' => 'required|same:confirm-password'
        ]);

        $user = User::find($id);
        $user->password= \Hash::make($request->password);
        $user->save();

        $notification = array(
            'message' => 'User has been changed password successfully.', 
            'alert-type' => 'success',
        );
        return back()->with($notification);
    }
    
    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        User::find($id)->delete();
        $notification = array(
            'message' => 'User has been deleted successfully.', 
            'alert-type' => 'success',
        );
        return redirect()->route('users.index')->with($notification);
    }

    public function userBlock($id)
    {
        $user = User::find($id);
        if($user->status == 0){
            $user->status= 1;
            $message = 'User has been unblock successfully.';
        }else{ 
            $user->status= 0;
            $message = 'User has been block successfully.';
        }
        $user->save();
        $notification = array(
            'message' => $message,
            'alert-type' => 'success',
        );
        return redirect()->route('users.index')->with($notification);
    }

    // public function displayImage($filename)
    // {
    //     $path = storage_public('photos/' . $filename);
    
    //     if (!File::exists($path)) {
    //         abort(404);
    //     }
    //     $file = File::get($path);
    //     $type = File::mimeType($path);  

    //     $response = Response::make($file, 200);
    //     $response->header("Content-Type", $type);

    //     return $response;
    // }
}

resources/views/users/change_password.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.change_password')}}</h1>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if (count($errors) > 0)
            <div class="alert alert-danger">
                <strong>Whoops!</strong> There were some problems with your input.
                <br>
                <br>
                <ul>
                    @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
            @endif
            <div class="card">                
                <div class="card-body">
                    <form role="form" method="POST" action="{{ url('updatePassword',$user->id) }}" novalidate>
                        {{ csrf_field() }}
                        {{ method_field('PUT') }}
                        <input type="hidden" name="id" value="{{$user->id}}">
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.new_password')}} <i class="text-red">*</i></strong>
                                <input type="password" name="password" class="form-control form-control-sm" id="password" placeholder="New password">
                                </div>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.confirm_password')}} <i class="text-red">*</i></strong>
                                <input type="password" name="confirm-password" class="form-control form-control-sm" id="confirm-password" placeholder="Confirm password">
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <button type="submit" class="btn btn-primary">{{ __('veacha.update_password')}}</button>
                            </div>  
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@section('js')
    <script>
        $(function () {
        });
    </script>
@include('notification') 
@endsection

resources/views/users/create.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.user')}}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="{{ route('users.index') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_list_user')}}</a>
                    </li>
                </ol>
            </div>
            <!-- /.col -->
        </div>
        <!-- /.row -->
    </div>
    <!-- /.container-fluid -->
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if (count($errors) > 0)
            <div class="alert alert-danger">
                <strong>Whoops!</strong> There were some problems with your input.
                <br>
                <br>
                <ul>
                    @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
            @endif
            <div class="card">
                
                <!-- /.card-header -->
                <div class="card-body">
                    <form role="form" action="{{ route('users.store') }}" method="POST" enctype="multipart/form-data">
                        {{csrf_field()}}
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.name')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="name" value="{{ old('name') }}" class="form-control form-control-sm" placeholder="Enter name">
                                </div>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.email')}} <i class="text-red">*</i></strong>
                                    <input type="email" name="email" value="{{ old('email') }}" class="form-control form-control-sm" placeholder="Enter email address">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.phone_number')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="phone" value="{{ old('phone') }}" class="form-control form-control-sm" placeholder="Enter phone number">
                                </div>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.password')}} <i class="text-red">*</i></strong>
                                    <input type="password" name="password" value="{{ old('password') }}" class="form-control form-control-sm" placeholder="Enter password">
                                </div>
                            </div>
                        </div>
                        <div class="row">                            
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.confirm_password')}} <i class="text-red">*</i></strong>
                                    <input type="password" name="confirm-password" value="{{ old('confirm-password') }}"  class="form-control form-control-sm" placeholder="Enter confirm password">
                                </div>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.role')}} <i class="text-red">*</i></strong>
                                    <select name="roles[]" class="select2" multiple="multiple" class="form-control form-control-sm" data-placeholder="Select a role" style="width: 100%;">
                                        @foreach ($roles as $role)
                                        <option value="{{ $role->id }}">{{ $role->name }}</option>
                                        @endforeach
                                    </select>
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.description')}} <i class="text-red">*</i> </strong> 
                                    <textarea class="form-control form-control-sm" rows="2" name="description" placeholder="Enter description">{{ old('description') }}</textarea>
                                </div>
                            </div>                            
                            <div class="col-xs-6 col-sm-6 col-md-6 text-center" style="display: inline-grid; padding-left: 150px;">
                                <img src="{{ asset('dist/img/user_default.png') }}" id="blah" class="img-thumbnail img-size-120" alt="user photo">
                                <input type='file' name="photo" class="btn col-3 btn-primary input-file" style="display: contents;" onchange="readURL(this);"/>
                                <button type="button" class="btn col-3 btn-primary button-photo" style="height: 35px; width: 500px;">{{ __('veacha.photo')}}</button>
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <button type="submit" class="btn btn-primary">{{ __('veacha.button_save')}}</button>
                            </div>  
                        </div>
                    </form>

                </div>
                <!-- /.card-body -->
            </div>

        </div>
    </div>
</div>
@endsection

resources/views/users/edit.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.user')}}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    <li class="breadcrumb-item"><a href="{{ route('users.index') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.user')}}</a>
                    </li>
                </ol>
            </div>
            <!-- /.col -->
        </div>
        <!-- /.row -->
    </div>
    <!-- /.container-fluid -->
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if (count($errors) > 0)
            <div class="alert alert-danger">
                <strong>Whoops!</strong> There were some problems with your input.
                <br>
                <br>
                <ul>
                    @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
            @endif
            <div class="card">                
                <div class="card-body">
                    <form role="form" action="{{ route('users.update', $user->id) }}" method="POST" enctype="multipart/form-data">
                        {{ csrf_field() }}
                        {{ method_field('PATCH') }}
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.name')}} <i class="text-red">*</i></strong>
                                <input type="text" name="name" class="form-control form-control-sm" placeholder="Enter name" value="{{$user->name}}">
                                </div>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.email')}} <i class="text-red">*</i></strong>
                                    <input type="email" name="email" class="form-control form-control-sm" placeholder="Enter email address" value="{{$user->email}}">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.phone_number')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="phone" class="form-control form-control-sm" placeholder="Enter phone number" value="{{$user->phone}}">
                                </div>
                            </div>
                        </div>
                        <div class="row">   
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.role')}} <i class="text-red">*</i></strong>
                                    {!! Form::select('roles[]', $roles,$userRole, array('class' => 'select2 form-control form-control-sm','multiple')) !!}
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.description')}} <i class="text-red">*</i> </strong>
                                    <textarea class="form-control form-control-sm" rows="2" name="description" placeholder="Enter description">{{$user->description}}</textarea>
                                </div>
                            </div>                            
                            <div class="col-xs-6 col-sm-6 col-md-6 text-center" style="display: inline-grid; padding-left: 150px;">
                                <img src="{{ URL::to('/') }}/photos/{{ $user->photo }}" id="blah" class="img-thumbnail img-size-120" alt="user photo">
                                <input type='file' name="photo" class="btn col-3 btn-primary input-file" style="display: contents;" onchange="readURL(this);"/>
                                <button type="button" class="btn col-3 btn-primary button-photo" style="height: 35px; width: 500px;">{{ __('veacha.photo')}}</button>
                            </div>
                        </div>
                        <br>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <button type="submit" class="btn btn-primary">{{ __('veacha.button_save')}}</button>
                            </div>  
                        </div>
                    </form>

                </div>
                <!-- /.card-body -->
            </div>

        </div>
    </div>
</div>
@endsection

resources/views/users/edit_user.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.button_edit_user')}}</h1>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if (count($errors) > 0)
            <div class="alert alert-danger">
                <strong>Whoops!</strong> There were some problems with your input.
                <br>
                <br>
                <ul>
                    @foreach ($errors->all() as $error)
                    <li>{{ $error }}</li>
                    @endforeach
                </ul>
            </div>
            @endif
            <div class="card">                
                <div class="card-body">
                    <form role="form" action="{{ url('updateUser', $user->id) }}" method="POST" enctype="multipart/form-data">
                        {{ csrf_field() }}
                        {{ method_field('PUT') }}
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.name')}} <i class="text-red">*</i></strong>
                                <input type="text" name="name" class="form-control form-control-sm" placeholder="Enter name" value="{{$user->name}}">
                                </div>
                            </div>
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.email')}} <i class="text-red">*</i></strong>
                                    <input type="email" name="email" class="form-control form-control-sm" placeholder="Enter email address" value="{{$user->email}}">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-6 col-sm-6 col-md-6">
                                <div class="form-group">
                                    <strong>{{ __('veacha.phone_number')}} <i class="text-red">*</i></strong>
                                    <input type="text" name="phone" class="form-control form-control-sm" placeholder="Enter phone number" value="{{$user->phone}}">
                                </div>
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <button type="submit" class="btn btn-primary">{{ __('veacha.button_update_user')}}</button>
                            </div>  
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection
@section('js')
    <script>
        $(function () {
        });
    </script>
@include('notification') 
@endsection